unit uHEXLog;

interface

uses
  Windows,
  Messages,
  SysUtils,
  Variants,
  Classes,
  Graphics,
  Controls,
  Forms,
  Dialogs,
  StdCtrls,
  ComCtrls,
  ToolWin,
  DateUtils,
  XPMan;

type
  TfrmHEXLog = class(TForm)
    Log: TRichEdit;
    tlb: TToolBar;
    ToolButton1: TToolButton;
    dlgSave: TSaveDialog;
    ToolButton2: TToolButton;
    ToolButton3: TToolButton;
    btnHoriMagnetWin: TToolButton;
    btnVertMagnetWin: TToolButton;
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FormCreate(Sender: TObject);
    procedure ToolButton1Click(Sender: TObject);
    procedure ToolButton2Click(Sender: TObject);
    procedure ToolButton3Click(Sender: TObject);
    procedure btnHoriMagnetWinClick(Sender: TObject);
    procedure btnVertMagnetWinClick(Sender: TObject);
  private
    MOV_Start: Boolean;
    Magnet: Boolean;
    mx, my: Integer;
    procedure WMMOVING(var msg: TMessage); message WM_MOVING;
    procedure WMMOVE(var msg: TMessage); message WM_MOVE;
  public
    { Public declarations }
  end;

var
  frmHEXLog: TfrmHEXLog;

implementation

uses
  uMain,
  uHExLogOpt;

{$R *.dfm}

procedure TfrmHEXLog.FormCloseQuery(Sender: TObject;
  var CanClose: Boolean);
begin
  CanClose := (Sender = frmMain);
end;

procedure TfrmHEXLog.FormCreate(Sender: TObject);
begin
  Left := ini.ReadInteger('Last', 'HexLogLeft', frmMain.BoundsRect.Right);
  Top := ini.ReadInteger('Last', 'HexLogTop', frmMain.Top);
  Width := ini.ReadInteger('Last', 'HexLogWidth', 300);
  Height := ini.ReadInteger('Last', 'HexLogHeight', frmMain.Height);
  if Left < 0 then
    Left := 0;
  if (Left + Width) > Screen.Width then
    Left := Screen.Width - Width;
  if Top < 0 then
    Top := 0;
  if (Top + Height) > Screen.Height then
    Top := Screen.Height - Height;
  frmMain.Magnet := False;
  if BoundsRect.Left = frmMain.BoundsRect.Right then
  begin
    frmMain.Magnet := True;
    frmMain.MagnetDir := 1;
  end;
  if BoundsRect.Top = frmMain.BoundsRect.Bottom then
  begin
    frmMain.Magnet := True;
    frmMain.MagnetDir := 2;
  end;
  if BoundsRect.Right = frmMain.BoundsRect.Left then
  begin
    frmMain.Magnet := True;
    frmMain.MagnetDir := 3;
  end;
  if BoundsRect.Bottom = frmMain.BoundsRect.Top then
  begin
    frmMain.Magnet := True;
    frmMain.MagnetDir := 4;
  end;
  MOV_Start := False;
  Magnet := frmMain.Magnet;
  Log.SelStart := Length(Log.Text);
  dlgSave.InitialDir := ExtractFileDir(Application.ExeName);
end;

procedure TfrmHEXLog.ToolButton1Click(Sender: TObject);
var
  s: string;
begin
  s := Format('%d%.02d%.02d_%.02d%.02d%.02d', [YearOf(now), MonthOf(now), DayOf(now), HourOf(now), MinuteOf(now), SecondOf(now)]);
  dlgSave.FileName := ExtractFilePath(dlgSave.FileName) + 'AT Command HEX Log ' + s + '.rtf';
  if dlgSave.Execute then
    Log.Lines.SaveToFile(dlgSave.FileName);
end;

procedure TfrmHEXLog.ToolButton2Click(Sender: TObject);
begin
  frmHEXLogOpt.ShowModal;
end;

procedure TfrmHEXLog.ToolButton3Click(Sender: TObject);
begin
  Log.Clear;
end;

procedure TfrmHEXLog.WMMOVE(var msg: TMessage);
begin
  MOV_Start := False;
  frmMain.Magnet := Magnet;
end;

procedure TfrmHEXLog.WMMOVING(var msg: TMessage);
begin
  GetCursorPos(mp);
  if not MOV_Start then
  begin
    MOV_Start := True;
    mx := mp.X;
    my := mp.Y;
  end;
  if Magnet then
  begin
    case frmMain.MagnetDir of
      1:
        begin
          if (Abs(mx - mp.X) > MagnetPower) then
          begin
            Magnet := False;
            PRect(msg.LParam)^.Left := frmMain.BoundsRect.Right + mp.X - mx;
            PRect(msg.LParam)^.Right := PRect(msg.LParam)^.Left + Width;
          end
          else
          begin
            PRect(msg.LParam)^.Left := frmMain.BoundsRect.Right;
            PRect(msg.LParam)^.Right := PRect(msg.LParam)^.Left + Width;
          end;
        end;
      2:
        begin
          if (Abs(my - mp.Y) > MagnetPower) then
          begin
            Magnet := False;
            PRect(msg.LParam)^.Top := frmMain.BoundsRect.Bottom + mp.Y - my;
            PRect(msg.LParam)^.Bottom := PRect(msg.LParam)^.Top + Height;
          end
          else
          begin
            PRect(msg.LParam)^.Top := frmMain.BoundsRect.Bottom;
            PRect(msg.LParam)^.Bottom := PRect(msg.LParam)^.Top + Height;
          end;
        end;
      3:
        begin
          if (Abs(mx - mp.X) > MagnetPower) then
          begin
            Magnet := False;
            PRect(msg.LParam)^.Right := frmMain.BoundsRect.Left + mp.X - mx;
            PRect(msg.LParam)^.Left := PRect(msg.LParam)^.Right - Width;
          end
          else
          begin
            PRect(msg.LParam)^.Right := frmMain.BoundsRect.Left;
            PRect(msg.LParam)^.Left := PRect(msg.LParam)^.Right - Width;
          end;
        end;
      4:
        begin
          if (Abs(my - mp.Y) > MagnetPower) then
          begin
            Magnet := False;
            PRect(msg.LParam)^.Bottom := frmMain.BoundsRect.Top + mp.Y - my;
            PRect(msg.LParam)^.Top := PRect(msg.LParam)^.Bottom - Height;
          end
          else
          begin
            PRect(msg.LParam)^.Bottom := frmMain.BoundsRect.Top;
            PRect(msg.LParam)^.Top := PRect(msg.LParam)^.Bottom - Height;
          end;
        end;
    end;
  end
  else
  begin
    if (Abs(PRect(msg.LParam)^.Left - frmMain.BoundsRect.Right) < MagnetPower) then
    begin
      if not ((PRect(msg.LParam)^.Top > frmMain.BoundsRect.Bottom) or (PRect(msg.LParam)^.Bottom < frmMain.Top)) then
      begin
        Magnet := True;
        frmMain.MagnetDir := 1;
        mx := mp.X;
        my := mp.Y;
        PRect(msg.LParam)^.Left := frmMain.BoundsRect.Right;
        PRect(msg.LParam)^.Right := PRect(msg.LParam)^.Left + Width;
      end;
    end
    else
      if (Abs(PRect(msg.LParam)^.Top - frmMain.BoundsRect.Bottom) < MagnetPower) then
      begin
        if not ((PRect(msg.LParam)^.Left > frmMain.BoundsRect.Right) or (PRect(msg.LParam)^.Right < frmMain.BoundsRect.Left)) then
        begin
          Magnet := True;
          frmMain.MagnetDir := 2;
          mx := mp.X;
          my := mp.Y;
          PRect(msg.LParam)^.Top := frmMain.BoundsRect.Bottom;
          PRect(msg.LParam)^.Bottom := PRect(msg.LParam)^.Top + Height;
        end;
      end
      else
        if (Abs(PRect(msg.LParam)^.Right - frmMain.BoundsRect.Left) < MagnetPower) then
        begin
          if not ((PRect(msg.LParam)^.Top > frmMain.BoundsRect.Bottom) or (PRect(msg.LParam)^.Bottom < frmMain.Top)) then
          begin
            Magnet := True;
            frmMain.MagnetDir := 3;
            mx := mp.X;
            my := mp.Y;
            PRect(msg.LParam)^.Right := frmMain.BoundsRect.Left;
            PRect(msg.LParam)^.Left := PRect(msg.LParam)^.Right - Width;
          end;
        end
        else
          if (Abs(PRect(msg.LParam)^.Bottom - frmMain.BoundsRect.Top) < MagnetPower) then
          begin
            if not ((PRect(msg.LParam)^.Left > frmMain.BoundsRect.Right) or (PRect(msg.LParam)^.Right < frmMain.BoundsRect.Left)) then
            begin
              Magnet := True;
              frmMain.MagnetDir := 4;
              mx := mp.X;
              my := mp.Y;
              PRect(msg.LParam)^.Bottom := frmMain.BoundsRect.Top;
              PRect(msg.LParam)^.Top := PRect(msg.LParam)^.Bottom - Height;
            end;
          end
  end;

end;

procedure TfrmHEXLog.btnHoriMagnetWinClick(Sender: TObject);
begin
  Magnet := True;
  frmMain.Magnet := True;
  Top := frmMain.Top;
  Height := frmMain.Height;
  if frmMain.Left < (Screen.Width - frmMain.BoundsRect.Right) then
  begin
    frmMain.MagnetDir := 1;
    Left := frmMain.BoundsRect.Right;
    if (BoundsRect.Right > Screen.Width) and (Screen.Width - Left > Constraints.MinWidth) then
      Width := Screen.Width - Left;
  end
  else
  begin
    frmMain.MagnetDir := 3;
    Left := frmMain.BoundsRect.Left - Width;
    if (Left < 0) and (frmMain.BoundsRect.Left > Constraints.MinWidth) then
    begin
      Left := 0;
      Width := frmMain.BoundsRect.Left;
    end;
  end;
end;

procedure TfrmHEXLog.btnVertMagnetWinClick(Sender: TObject);
begin
  Magnet := True;
  frmMain.Magnet := True;
  Left := frmMain.Left;
  Width:= frmMain.Width;
  if frmMain.Top < (Screen.Height - frmMain.BoundsRect.Bottom) then
  begin
    frmMain.MagnetDir := 2;
    Top := frmMain.BoundsRect.Bottom;
    if (BoundsRect.Bottom> Screen.Height) and (Screen.Height- Top > Constraints.MinHeight) then
      Height:= Screen.Width - Top;
  end
  else
  begin
    frmMain.MagnetDir := 4;
    Top := frmMain.BoundsRect.Top - Height;
    if (Top < 0) and (frmMain.BoundsRect.Top > Constraints.MinHeight) then
    begin
      Top := 0;
      Height := frmMain.BoundsRect.Top;
    end;
  end;
end;

end.

