unit uHExLogOpt;

interface

uses
  Windows,
  Messages,
  SysUtils,
  Variants,
  Classes,
  Graphics,
  Controls,
  Forms,
  Dialogs,
  StdCtrls,
  Buttons,
  PngBitBtn,
  ExtCtrls,
  PngSpeedButton;

type
  TfrmHEXLogOpt = class(TForm)
    dlgColor: TColorDialog;
    btnCancel: TPngSpeedButton;
    btnOk: TPngSpeedButton;
    GroupBox1: TGroupBox;
    Label1: TLabel;
    shpTXD: TShape;
    Label2: TLabel;
    shpRXD: TShape;
    procedure FormCreate(Sender: TObject);
    procedure btnCancelClick(Sender: TObject);
    procedure btnOkClick(Sender: TObject);
    procedure shpTXDMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure shpRXDMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmHEXLogOpt: TfrmHEXLogOpt;

implementation

uses uMain;

{$R *.dfm}

procedure TfrmHEXLogOpt.FormCreate(Sender: TObject);
begin
  shpTXD.Brush.Color := frmMain.TXDColor;
  shpRXD.Brush.Color := frmMain.RXDColor;
end;

procedure TfrmHEXLogOpt.btnCancelClick(Sender: TObject);
begin
  Close;
end;

procedure TfrmHEXLogOpt.btnOkClick(Sender: TObject);
begin
  frmMain.TXDColor := shpTXD.Brush.Color;
  frmMain.RXDColor := shpRXD.Brush.Color;
  ini.WriteString('cfg', 'TXDColor', ColorToString(frmMain.TXDColor));
  ini.WriteString('cfg', 'RXDColor', ColorToString(frmMain.RXDColor));
  Close;
end;

procedure TfrmHEXLogOpt.shpTXDMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  dlgColor.Color := shpTXD.Brush.Color;
  if dlgColor.Execute then
  begin
    shpTXD.Brush.Color := dlgColor.Color;
  end;
end;

procedure TfrmHEXLogOpt.shpRXDMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  dlgColor.Color := shpRXD.Brush.Color;
  if dlgColor.Execute then
  begin
    shpRXD.Brush.Color := dlgColor.Color;
  end;
end;

end.

