unit uMain;

interface

uses
  Windows,
  Messages,
  SysUtils,
  Classes,
  Graphics,
  Controls,
  Forms,
  Dialogs,
  ComCtrls,
  CPortCtl,
  CPort,
  DateUtils,
  ImgList,
  ToolWin,
  ExtCtrls,
  ShellAPI,
  MemoEx,
  StdCtrls,
  Buttons,
  XPMan,
  FastIniFile,
  PngImageList;

const
  VERSION = '1.26';
  MagnetPower = 36;

type
  TComPortBuf = array[0..10000] of Byte;
  TfrmMain = class(TForm)
    tlb: TToolBar;
    comport: TComPort;
    Stat: TPanel;
    cmldTX: TComLed;
    cmldRX: TComLed;
    btnComportOpt: TToolButton;
    ToolButton2: TToolButton;
    ToolButton3: TToolButton;
    ToolButton4: TToolButton;
    tmrAuto: TTimer;
    tlbBtn: TToolBar;
    btnATCmd1: TToolButton;
    btnSave: TToolButton;
    btnOnOff: TToolButton;
    tmrRX: TTimer;
    tmrTX: TTimer;
    Log: TMemo;
    ToolButton1: TToolButton;
    ToolButton8: TToolButton;
    ToolButton9: TToolButton;
    tmrAni: TTimer;
    dlgSave: TSaveDialog;
    PngImageList: TPngImageList;
    ToolButton5: TToolButton;
    ToolBar1: TToolBar;
    cbbcmd: TComboBox;
    btnEnter: TSpeedButton;
    procedure ToolButton4Click(Sender: TObject);
    procedure btnComportOptClick(Sender: TObject);
    procedure btnOnOffClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure cbbcmdDblClick(Sender: TObject);
    procedure cbbcmdKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure tmrRXTimer(Sender: TObject);
    procedure tmrTXTimer(Sender: TObject);
    procedure comportRxChar(Sender: TObject; Count: Integer);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure LogClick(Sender: TObject);
    procedure LogKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FormShow(Sender: TObject);
    procedure btnSaveClick(Sender: TObject);
    procedure ToolButton2Click(Sender: TObject);
    procedure ToolButton5Click(Sender: TObject);
    procedure ToolButton3Click(Sender: TObject);
    procedure tlbBtnMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure FormResize(Sender: TObject);
  private
    procedure WMMOVING(var msg: TMessage); message WM_MOVING;
    procedure WMMOVE(var msg: TMessage); message WM_MOVE;
    //    procedure WMSIZING(var msg: TMessage); message WM_SIZING;
    //    procedure WMSIZE(var msg: TMessage); message WM_SIZE;
    procedure FormMoved;
  public
    MOV_RECT: TRect;
    MOV_Start: Boolean;
    Magnet: Boolean;
    MagnetDir: Byte;
    TXDColor, RXDColor: TColor;
    procedure DisplayHint(Sender: TObject);
    procedure FirstFormShow(Sender: TObject);
    procedure HEXLog(s: string; Color: TColor); overload;
    procedure SetButton;
    procedure btnATCmdClick(Sender: TObject);
    procedure btnATCmdMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure btnATCmdMouseUp(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure btnATCmdMouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer);
  end;

var
  frmMain: TfrmMain;
  ini: TFastIniFile;
  mp: TPoint;
  EchoChar: Boolean;

implementation

uses
  uAbout,
  uOption,
  uHEXLog;

{$R *.dfm}

procedure TfrmMain.ToolButton4Click(Sender: TObject);
var
  frmAbout: TfrmAbout;
begin
  frmAbout := TfrmAbout.Create(Self);
  frmAbout.ShowModal;
  frmAbout.Free;
  BringToFront;
  if Win32Platform = VER_PLATFORM_WIN32_NT then
    SetProcessWorkingSetSize(GetCurrentProcess, $FFFFFFFF, $FFFFFFFF);
end;

procedure TfrmMain.btnComportOptClick(Sender: TObject);
begin
  comport.ShowSetupDialog;
  comport.StoreSettings(stIniFile, ChangeFileExt(ParamStr(0), '.ini'));
  ini.Rename(ChangeFileExt(ParamStr(0), '.ini'), TRUE);
  if Win32Platform = VER_PLATFORM_WIN32_NT then
    SetProcessWorkingSetSize(GetCurrentProcess, $FFFFFFFF, $FFFFFFFF);
end;

procedure TfrmMain.btnOnOffClick(Sender: TObject);
begin
  if btnOnOff.Down then
  begin
    try
      if comport.Port = '' then
        btnComportOptClick(Sender);
      comport.Open;
    except
      Application.MessageBox('      Open comport fail!      ' + #13#10,
        'Error!',
        MB_OK + MB_ICONSTOP);
      Exit;
    end;
  end
  else
  begin
    try
      comport.Close;
    except
      Application.MessageBox('      Close comport fail!      ' + #13#10,
        'Error!',
        MB_OK + MB_ICONSTOP);
      Exit;
    end;
  end;

  if btnOnOff.Down then
  begin
    btnOnOff.Hint := 'Close Comport';
    btnOnOff.ImageIndex := 6;
  end
  else
  begin
    btnOnOff.Hint := 'Open Comport';
    btnOnOff.ImageIndex := 5;
  end;
  btnEnter.Enabled := btnOnOff.Down;
  cbbcmd.Enabled := btnOnOff.Down;
  tlbBtn.Enabled := btnOnOff.Down;
  if cbbcmd.Enabled then
    LogClick(Sender);
  if Win32Platform = VER_PLATFORM_WIN32_NT then
    SetProcessWorkingSetSize(GetCurrentProcess, $FFFFFFFF, $FFFFFFFF);
end;

procedure TfrmMain.DisplayHint(Sender: TObject);
begin
  Stat.Caption := GetLongHint(Application.Hint);
end;

procedure TfrmMain.FormCreate(Sender: TObject);
begin
  Caption := 'AT Commander ' + VERSION;
  Application.Title := Caption;
  Application.HintPause := 100;
  Application.HintHidePause := 5000;
  Application.OnHint := DisplayHint;
  comport.Port := '';
  comport.LoadSettings(stIniFile, ChangeFileExt(ParamStr(0), '.ini'));
  ini := TFastIniFile.Create(ChangeFileExt(ParamStr(0), '.ini'));
  Left := ini.ReadInteger('Last', 'Left', 0);
  Top := ini.ReadInteger('Last', 'Top', 0);
  Width := ini.ReadInteger('Last', 'Width', 500);
  Height := ini.ReadInteger('Last', 'Height', 480);
  if Left < 0 then
    Left := 0;
  if (Left + Width) > Screen.Width then
    Left := Screen.Width - Width;
  if Top < 0 then
    Top := 0;
  if (Top + Height) > Screen.Height then
    Top := Screen.Height - Height;
  ini.ReadStrings('CmdHis', 'CMD', cbbcmd.Items);
  TXDColor := StringToColor(ini.ReadString('cfg', 'TXDColor', '$00C08000'));
  RXDColor := StringToColor(ini.ReadString('cfg', 'RXDColor', '$00208000'));
  dlgSave.InitialDir := ExtractFileDir(Application.ExeName);
  Log.WordWrap := False;
  Log.ScrollBars := ssBoth;
  Log.Lines.Add('');
  Log.Lines.Add('');
  MOV_Start := False;

  EchoChar := ini.ReadBoolean('cfg', 'EchoChar', False);
  if not ini.SectionExists('Button') then
  begin
    ini.WriteInteger('Button', 'Count', 5);
    ini.WriteString('Button', 'Name' + IntToStr(1), 'AT');
    ini.WriteString('Button', 'ATCmd' + IntToStr(1), 'AT');
    ini.WriteBoolean('Button', 'Checked' + IntToStr(1), TRUE);
    ini.WriteString('Button', 'Name' + IntToStr(2), 'CMGS');
    ini.WriteString('Button', 'ATCmd' + IntToStr(2), 'AT+CMGS=""');
    ini.WriteBoolean('Button', 'Checked' + IntToStr(2), TRUE);
    ini.WriteString('Button', 'Name' + IntToStr(3), 'CMGR');
    ini.WriteString('Button', 'ATCmd' + IntToStr(3), 'AT+CMGR=');
    ini.WriteBoolean('Button', 'Checked' + IntToStr(3), TRUE);
    ini.WriteString('Button', 'Name' + IntToStr(4), 'CPAS');
    ini.WriteString('Button', 'ATCmd' + IntToStr(4), 'AT+CPAS');
    ini.WriteBoolean('Button', 'Checked' + IntToStr(4), TRUE);
    ini.WriteString('Button', 'Name' + IntToStr(5), 'CEER');
    ini.WriteString('Button', 'ATCmd' + IntToStr(5), 'AT+CEER');
    ini.WriteBoolean('Button', 'Checked' + IntToStr(5), TRUE);
  end;
  SetButton;
end;

procedure TfrmMain.cbbcmdDblClick(Sender: TObject);
var
  s: string;
  i: Integer;
begin
  s := cbbcmd.Text;

  i := cbbcmd.Items.IndexOf(s);
  if i <> -1 then
  begin
    cbbcmd.Items.Delete(i);
  end;
  cbbcmd.Items.Insert(0, s);
  if cbbcmd.Items.Count > 18 then
    cbbcmd.Items.Delete(cbbcmd.Items.Count - 1);
  cbbcmd.Text := s;

  comport.WriteStr(s + #13#10);
  tmrTX.Enabled := TRUE;
  cmldTX.State := lsOn;

  if EchoChar then
    Log.Lines.Append(s);

  HEXLog(s + #13#10, TXDColor);

  cbbcmd.SetFocus;
  cbbcmd.SelectAll;
end;

procedure TfrmMain.cbbcmdKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var
  buf: TComPortBuf;
begin
  if Key = VK_RETURN then
    cbbcmdDblClick(Sender);
  if ((Key = Ord('Z')) or (Key = Ord('z'))) and (Shift = [ssCtrl]) then
  begin
    Key := $0;
    cbbcmdDblClick(Sender);
    buf[0] := $1A;
    comport.Write(buf, 1);
    cbbcmd.Text := '';
    HEXLog(#26, TXDColor);
  end;
end;

procedure TfrmMain.tmrRXTimer(Sender: TObject);
begin
  tmrRX.Enabled := False;
  cmldRX.State := lsOff;
end;

procedure TfrmMain.tmrTXTimer(Sender: TObject);
begin
  tmrTX.Enabled := False;
  cmldTX.State := lsOff;
end;

procedure TfrmMain.comportRxChar(Sender: TObject; Count: Integer);
var
  s: string;
begin
  tmrRX.Enabled := TRUE;
  s := '';
  comport.ReadStr(s, Count);
  cmldRX.State := lsOn;
  Log.Lines[Log.Lines.Count - 1] := Log.Lines[Log.Lines.Count - 1] + s;
  HEXLog(s, RXDColor);
end;

procedure TfrmMain.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  ini.WriteInteger('Last', 'Left', Left);
  ini.WriteInteger('Last', 'Top', Top);
  ini.WriteInteger('Last', 'Width', Width);
  ini.WriteInteger('Last', 'Height', Height);
  ini.WriteInteger('Last', 'HexLogLeft', frmHEXLog.Left);
  ini.WriteInteger('Last', 'HexLogTop', frmHEXLog.Top);
  ini.WriteInteger('Last', 'HexLogWidth', frmHEXLog.Width);
  ini.WriteInteger('Last', 'HexLogHeight', frmHEXLog.Height);
  ini.WriteStrings('CmdHis', 'CMD', cbbcmd.Items);
  ini.Free;
  frmHEXLog.Visible := False;
  if (Win32MajorVersion > 4) and (Win32Platform = VER_PLATFORM_WIN32_NT) then
  begin
    AnimateWindow(frmMain.Handle, 1000, AW_BLEND or AW_HIDE);
  end
end;

procedure TfrmMain.LogClick(Sender: TObject);
begin
  if not cbbcmd.Enabled then
    Exit;

  cbbcmd.SetFocus;
  cbbcmd.SelStart := Length(cbbcmd.Text);
end;

procedure TfrmMain.LogKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  LogClick(Sender);
end;

procedure TfrmMain.FirstFormShow(Sender: TObject);
begin
  tlbBtn.Enabled := False;
  if (Win32MajorVersion > 4) and (Win32Platform = VER_PLATFORM_WIN32_NT) then
  begin
    AnimateWindow(frmMain.Handle, 1000, AW_BLEND or AW_ACTIVATE);
  end;
  frmHEXLog.Show;
  cbbcmd.Repaint;
  SetFocus;
end;

procedure TfrmMain.FormShow(Sender: TObject);
begin
  FirstFormShow(Sender);
  onShow := nil;
end;

procedure TfrmMain.btnSaveClick(Sender: TObject);
var
  s: string;
begin
  s := Format('%d%.02d%.02d_%.02d%.02d%.02d', [YearOf(now), MonthOf(now), DayOf(now), HourOf(now), MinuteOf(now), SecondOf(now)]);
  dlgSave.FileName := ExtractFilePath(dlgSave.FileName) + 'AT Command Log ' + s + '.txt';
  if dlgSave.Execute then
    Log.Lines.SaveToFile(dlgSave.FileName);
  if Win32Platform = VER_PLATFORM_WIN32_NT then
    SetProcessWorkingSetSize(GetCurrentProcess, $FFFFFFFF, $FFFFFFFF);
end;

procedure TfrmMain.ToolButton2Click(Sender: TObject);
begin
  if frmOption.ShowModal = mrOK then
    SetButton;
  if Win32Platform = VER_PLATFORM_WIN32_NT then
    SetProcessWorkingSetSize(GetCurrentProcess, $FFFFFFFF, $FFFFFFFF);
end;

procedure TfrmMain.HEXLog(s: string; Color: TColor);
var
  hs: string;
  i: Integer;
begin
  hs := '';
  for i := 1 to Length(s) do
    hs := hs + IntToHex(Ord(s[i]), 2) + ' ';
  frmHEXLog.Log.SelStart := Length(frmHEXLog.Log.Text);
  frmHEXLog.Log.SelAttributes.Color := Color;
  //  frmHEXLog.Log.SelLength := 0;
  frmHEXLog.Log.SelText := hs + #13#10;
  SendMessage(frmHEXLog.Log.Handle, EM_SCROLL, SB_LINEDOWN, 0);
end;

procedure TfrmMain.btnATCmdClick(Sender: TObject);
var
  s: string;
begin
  s := TToolButton(Sender).Hint;
  cbbcmd.Text := s;
  if Length(s) > 1 then
    if s[Length(s)] = '"' then
      cbbcmd.SelStart := Length(s) - 1
    else
      cbbcmd.SelStart := Length(s);
  cbbcmd.SelLength := 0;
end;

procedure TfrmMain.SetButton;
var
  i: Integer;
begin
  for i := tlbBtn.ButtonCount - 1 downto 0 do
    tlbBtn.Buttons[i].Free;
  if ini.ReadInteger('Button', 'Count', 0) = 0 then
  begin
    tlbBtn.Visible := False;
  end
  else
  begin
    tlbBtn.Visible := TRUE;
    for i := ini.ReadInteger('Button', 'Count', 0) downto 1 do
    begin
      if ini.ReadBoolean('Button', 'Checked' + IntToStr(i), False) then
      begin
        with TToolButton.Create(tlbBtn) do
        begin
          Parent := tlbBtn;
          Caption := ini.ReadString('Button', 'Name' + IntToStr(i), 'Cmd' + IntToStr(i));
          Hint := ini.ReadString('Button', 'ATCmd' + IntToStr(i), '');
          AutoSize := TRUE;
          OnClick := btnATCmdClick;
          OnMouseDown := btnATCmdMouseDown;
          OnMouseUp := btnATCmdMouseUp;
          OnMouseMove := btnATCmdMouseMove;
          Tag := i;
        end;
      end;
    end;
    if tlbBtn.ButtonCount = 0 then
      tlbBtn.Visible := False;
  end;
end;

procedure TfrmMain.btnATCmdMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  if Button = mbRight then
  begin
    TToolButton(Sender).Down := TRUE;
  end;
end;

procedure TfrmMain.btnATCmdMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var
  s: string;
begin
  if Button = mbRight then
  begin
    TToolButton(Sender).Down := False;
    s := TToolButton(Sender).Hint;
    cbbcmd.Text := s;
    cbbcmdDblClick(Sender);
  end;
end;

procedure TfrmMain.btnATCmdMouseMove(Sender: TObject; Shift: TShiftState;
  X, Y: Integer);
begin

end;

procedure TfrmMain.ToolButton5Click(Sender: TObject);
begin
  Log.Clear;
  if Win32Platform = VER_PLATFORM_WIN32_NT then
    SetProcessWorkingSetSize(GetCurrentProcess, $FFFFFFFF, $FFFFFFFF);
end;

procedure TfrmMain.ToolButton3Click(Sender: TObject);
begin
  if Win32Platform = VER_PLATFORM_WIN32_NT then
    SetProcessWorkingSetSize(GetCurrentProcess, $FFFFFFFF, $FFFFFFFF);
  Application.MessageBox(' Not finished.     ' + #13#10#13#10 + ' Please visit my web for last version:' + #13#10 + '   http://shaoziyang.googlepages.com/avrub.htm',
    'Warning',
    MB_OK + MB_ICONINFORMATION);
end;

procedure TfrmMain.WMMOVE(var msg: TMessage);
begin
  if Magnet then
  begin
    case MagnetDir of
      1, 3: frmHEXLog.btnHoriMagnetWin.Click;
      2, 4: frmHEXLog.btnVertMagnetWin.Click;
    end;
  end;
end;

procedure TfrmMain.WMMOVING(var msg: TMessage);
begin
  if not MOV_Start then
  begin
    MOV_Start := TRUE;
    MOV_RECT := BoundsRect;
  end;
end;

//procedure TfrmMain.WMSIZE(var msg: TMessage);
//begin
//
//end;

//procedure TfrmMain.WMSIZING(var msg: TMessage);
//begin
//end;

procedure TfrmMain.tlbBtnMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
var
  i: Integer;
begin
  for i := 1 to tlbBtn.ButtonCount do
    if tlbBtn.Buttons[i - 1].Down then
      tlbBtn.Buttons[i - 1].Down := False;
end;

procedure TfrmMain.FormMoved;
begin
  MOV_Start := False;
  if Magnet then
  begin
    case MagnetDir of
      1:
        begin
          frmHEXLog.Left := BoundsRect.Right;
          frmHEXLog.Top := frmHEXLog.Top + BoundsRect.Top - MOV_RECT.Top;
        end;
      2:
        begin
          frmHEXLog.Left := frmHEXLog.Left + BoundsRect.Left - MOV_RECT.Left;
          frmHEXLog.Top := BoundsRect.Bottom;
        end;
      3:
        begin
          frmHEXLog.Left := BoundsRect.Left - frmHEXLog.Width;
          frmHEXLog.Top := frmHEXLog.Top + BoundsRect.Top - MOV_RECT.Top;
        end;
      4:
        begin
          frmHEXLog.Left := frmHEXLog.Left + BoundsRect.Left - MOV_RECT.Left;
          frmHEXLog.Top := BoundsRect.Top - frmHEXLog.Height;
        end;
    end;
  end;
end;

procedure TfrmMain.FormResize(Sender: TObject);
begin
  if Magnet then
  begin
    case MagnetDir of
      1, 3: frmHEXLog.btnHoriMagnetWin.Click;
      2, 4: frmHEXLog.btnVertMagnetWin.Click;
    end;
  end;
  cbbcmd.Width := ClientWidth - btnEnter.Width - 4;
end;

end.

