unit uOption;

interface

uses
  Windows,
  Messages,
  SysUtils,
  Variants,
  Classes,
  Graphics,
  Controls,
  Forms,
  Dialogs,
  Buttons,
  PngSpeedButton,
  ComCtrls,
  ExtCtrls,
  StdCtrls;

type
  TfrmOption = class(TForm)
    btnCancel: TPngSpeedButton;
    btnOk: TPngSpeedButton;
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    lvBtn: TListView;
    Panel1: TPanel;
    tsNormal: TTabSheet;
    chkEchoChar: TCheckBox;
    btnAdd: TSpeedButton;
    btnEdit: TSpeedButton;
    btnDel: TSpeedButton;
    procedure btnCancelClick(Sender: TObject);
    procedure btnOkClick(Sender: TObject);
    procedure btnAddClick(Sender: TObject);
    procedure btnDelClick(Sender: TObject);
    procedure btnEditClick(Sender: TObject);
    procedure lvBtnDblClick(Sender: TObject);
    procedure lvBtnSelectItem(Sender: TObject; Item: TListItem;
      Selected: Boolean);
    procedure FormShow(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmOption: TfrmOption;

implementation

uses uMain;

{$R *.dfm}

procedure TfrmOption.btnCancelClick(Sender: TObject);
begin
  Close;
end;

procedure TfrmOption.btnOkClick(Sender: TObject);
var
  i: Integer;
begin
  EchoChar := chkEchoChar.Checked;
  ini.WriteBoolean('cfg','EchoChar',EchoChar);
  ini.EraseSection('Button');
  ini.WriteInteger('Button', 'Count', lvBtn.Items.Count);
  for i := 1 to lvBtn.Items.Count do
  begin
    ini.WriteString('Button', 'Name' + IntToStr(i), lvBtn.Items[i - 1].Caption);
    ini.WriteString('Button', 'ATCmd' + IntToStr(i), lvBtn.Items[i - 1].SubItems[0]);
    ini.WriteBoolean('Button', 'Checked' + IntToStr(i), lvBtn.Items[i - 1].Checked);
  end;
  ModalResult := mrOk;
end;

procedure TfrmOption.btnAddClick(Sender: TObject);
var
  BtnName, BtnCmd: string;
begin
  BtnName := 'Cmd' + IntToStr(lvBtn.Items.Count + 1);
  if InputQuery('Add a Shortcut Button', 'Name', BtnName) then
  begin
    if BtnName = '' then
      Exit;
    BtnCmd := InputBox('Input a AT Command', 'command', '');
    with lvBtn.Items.Add do
    begin
      Caption := BtnName;
      SubItems.Add(BtnCmd);
      Checked := TRUE;
    end;
  end;
end;

procedure TfrmOption.btnDelClick(Sender: TObject);
begin
  if lvBtn.Selected <> nil then
    lvBtn.Selected.Delete;
end;

procedure TfrmOption.btnEditClick(Sender: TObject);
var
  BtnName, BtnCmd: string;
begin
  if lvBtn.Selected = nil then
  begin
    Exit;
  end
  else
  begin
    BtnName := lvBtn.Selected.Caption;
    if InputQuery('Edit a Shortcut Button', 'Name', BtnName) then
    begin
      if BtnName = '' then
        Exit
      else
        lvBtn.Selected.Caption := BtnName;
      BtnCmd := InputBox('Input a AT Command', 'command', lvBtn.Selected.SubItems[0]);
      lvBtn.Selected.SubItems[0] := BtnCmd;
    end;
  end;
end;

procedure TfrmOption.lvBtnDblClick(Sender: TObject);
begin
  if lvBtn.Selected = nil then
    btnAddClick(Sender)
  else
    btnEditClick(Sender);
end;

procedure TfrmOption.lvBtnSelectItem(Sender: TObject; Item: TListItem;
  Selected: Boolean);
begin
  btnEdit.Enabled := Selected;
  btnDel.Enabled := Selected;
end;

procedure TfrmOption.FormShow(Sender: TObject);
var
  i: Integer;
begin
  ModalResult := mrCancel;
  lvBtn.Clear;
  for i := 1 to ini.ReadInteger('Button', 'Count', 0) do
  begin
    with lvBtn.Items.Add do
    begin
      Caption := ini.ReadString('Button', 'Name' + IntToStr(i), 'Cmd' + IntToStr(i));
      SubItems.Add(ini.ReadString('Button', 'ATCmd' + IntToStr(i), ''));
      Checked := ini.ReadBoolean('Button', 'Checked' + IntToStr(i), FALSE);
    end;
  end;
  lvBtn.OnSelectItem(Sender,nil, FALSE);
  chkEchoChar.Checked := EchoChar;
end;

end.

